Redis Configuration

* Explain:
    * agents
    * resources
    * downward API
    * readiness probes
    * clusterbus
    * boot script

Liveness Probe

Suppose that a Pod is running our application inside a container, but due to some reasons let’s say memory leak, cpu
usage, application deadlock etc. the application is not responding to our requests, and stuck in error state.

Liveness probe checks the container health as we tell it do, and if for some reason the liveness probe fails, it
restarts the container.

Readiness Probe

In some cases we would like our application to be alive, but not serve traffic unless some conditions are met e.g,
populating a dataset, waiting for some other service to be alive etc. In such cases we use readiness probe. If the
condition inside readiness probe passes, only then our application can serve traffic.

Type of Probes The next step is to define the probes that test readiness and liveness. There are three types of probes:
HTTP, Command, and TCP. You can use any of them for liveness and readiness checks. HTTP probes are probably the most
common type of custom liveness probe. Even if your app isn’t an HTTP server, you can create a lightweight HTTP server
inside your app to respond to the liveness probe. Kubernetes pings a path, and if it gets an HTTP response in the 200 or
300 range, it marks the app as healthy. Otherwise, it is marked as unhealthy.

You can read more about HTTP probes here. Command For command probes, Kubernetes runs a command inside your container.
If the command returns with exit code 0, then the container is marked as healthy. Otherwise, it is marked unhealthy.
This type of probe is useful when you can’t or don’t want to run an HTTP server, but can run a command that can check
whether your app is healthy.

You can read more about command probes here. TCP The last type of probe is the TCP probe, where Kubernetes tries to
establish a TCP connection on the specified port. If it can establish a connection, the container is considered healthy;
if it can not establish a connection, is considered unhealthy.

TCP probes come in handy if you have a scenario where HTTP probes or command probe don’t work well. For example, a gRPC
or FTP service is a prime candidate for this type of probe.

You can read more about TCP probes here.